// Bios.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include "iostream.h"
#include "io.h"
#include <sys/stat.h>
#include <stdlib.h>



int main(int argc, char* argv[])
{
	int fileHandle; //Handle for output file
	float theCPUId; //Actual CPUID
	char NoCPUSupport[] = "This processor doesn't support a cpu_id instruction. Exiting... \n";
	char CPUSupport[] = "Cpu_id instruction is supported. Proceeding... \n";

	//First check for cpu_id instruction available
 
	_asm{
        pushfd                   //push original EFLAGS
        pop     eax              //get original EFLAGS in eax
        mov     ecx,eax          //save original EFLAGS in ecx
        or      eax,200000h      //flip ID bit in EFLAGS
        push    eax              //save for EFLAGS
        popfd                    //copy to EFLAGS
        pushfd                   //push EFLAGS
        pop     eax              //get new EFLAGS value
        xor     eax,ecx
        jne     continue_exec    //if ID bit cannot be changed,
                                 //CPU=Intel486 ot lower without 
								 //CPUID instruction functionality
	}

	//Display error message
	cout << NoCPUSupport;
	return 1;

	continue_exec:
		//CPUID supported, continue
		cout << CPUSupport;
	

	//Get cpu id
		_asm{

		mov     eax, 1
        cpuid
        mov     theCPUId, eax

	}
	
		
	//Create a file
	fileHandle = _creat( "1cprt.hid", _S_IREAD | _S_IWRITE );

	if( fileHandle == -1 ){
		cout << "Couldn't create file";
		return 2;
	}
	else{
      cout << "File was created.\n" ;
	}

	//Write to a file
	int decimalPosition, sign;
	char* stringID = _ecvt(theCPUId, 15, &decimalPosition, &sign);
	int bytesWritten = _write(fileHandle, stringID, 15);
	
    if (bytesWritten  == -1 ){
        cout << "Writing to a file failed";
		return 3;
	}
    else{
        cout << "The identification number of your processor has been written"<< "\n";
	}

	//Close file handle
	_close(fileHandle);

	return 0;
}